#ifndef __ucr_param_H
#define __ucr_param_H
/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: param.h,v 1.2 1996/10/28 03:44:56 steve Exp $"
/*
 * $Log: param.h,v $
 * Revision 1.2  1996/10/28 03:44:56  steve
 *  License notice.
 *
 * Revision 1.1  1996/08/02 00:18:36  steve
 *  Move the param.h header file.
 *
 * Revision 1.2  1996/05/29 21:41:23  steve
 *  Include symbols for fixed ISR numbers.
 *
 * Revision 1.1  1996/05/29 04:35:09  steve
 *  Support interrupts in the i960_cyclone world, and in the
 *  process reorganize interrupt code for portability.
 *
 */

/*
 * The Cyclone boards run the i960 in decicated mode, and support 8
 * external sources and 2 timer interrupts. Thus, only 10 possible
 * values can be passed to set_isr. Those in turn have meanings
 * assigned by Cyclone.
 */
# define MAX_EXCEPTION 10

# define CPU_TIMER0 0
# define CPU_TIMER1 1
# define XINT0 2
# define XINT1 3
# define XINT2 4
# define XINT3 5
# define XINT4 6
# define XINT5 7
# define XINT6 8
# define XINT7 9

/*
 * Since the numbers are preassigned to hardware 1-to-1, there is no
 * need to support more then one ISR per interrupt.
 */
# define MAX_ISR_PER_EXCEPTION 1

#endif
