/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *   Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 *
 * "$Id: dram.ld,v 1.4 1996/10/28 03:44:58 steve Exp $"
 *
 * $Log: dram.ld,v $
 * Revision 1.4  1996/10/28 03:44:58  steve
 *  License notice.
 *
 * Revision 1.3  1996/08/10 04:05:12  steve
 *  Inline the thread_spl things where possible,
 *  stop basing heap on estack, and fix startup
 *  code to use end_heap.
 *
 * Revision 1.2  1996/07/22 17:57:51  steve
 *  Enable tracing at non-interrupt level,
 *  make the locore startup code allocate the stack
 *  frame to be used.
 *
 * Revision 1.1  1996/05/29 04:31:10  steve
 *  Support standard linker configurations.
 *
 */

/*
 * The memory of the Cyclone 911 board looks like this. Link into this
 * space as you see fit.
 *
 * This file supports the dram model: That is, the program and data
 * go into the dram of the board.
 */

MEMORY
{
	dram  :  org = 0x60040000, len = 0x1c0000  /* 2Mb less monitor */
	flash :  org = 0xfef00000, len = 0x0d0000  /* 2Mb less mon960 */
}


ENTRY(start)
STARTUP(locore.o)

SECTIONS
{
	.text : { *(.text)
		  . = ALIGN(4);
		  ___CTOR_TABLE__ = .;
		  *(.ctors)
		  LONG(0);
		  ___DTOR_TABLE__ = .;
		  *(.dtors)
		  LONG(0); } >dram

	.data : { . = ALIGN(16); _etext = .; _bdata = .;
		  *(.data)
		  *(COMMON)
		  _edata = .; } >dram

	.bss  : { *(.bss)
		  _end = .;  }  >dram

	_end_heap = ABSOLUTE(0x60040000+0x1c0000);
}
