#ifndef __sparc_ucr_asm_H
#define __sparc_ucr_asm_H
/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: ucr_asm.h,v 1.2 1996/11/09 04:34:22 steve Exp $"
/*
 * $Log: ucr_asm.h,v $
 * Revision 1.2  1996/11/09 04:34:22  steve
 *  Add i386_linux thread infrastructure.
 *
 * Revision 1.1  1996/11/08 21:40:23  steve
 *  Divide up thread_create for easier porting, Add the
 *  sparc_linux and i386_linux targets, and adjust makefiles
 *  to allow for them. Document the new concept of virtual boards.
 *
 *  Change the linker output file extension to .exe, because
 *  some targets use ELF and not COFF.
 *
 *  Get rid of some trivial warnings.
 *
 */

/* NOTE:
 * You should be getting at this header file by including
 *	<ucr/config.h>
 * This is a header file put in the target specific include directory
 * and includes the header for the right CPU type, like this one if
 * you are using an i386.
 */

/* NOTE:
 * This header file may be included by C or C++ alike. I need to make
 * sure things are parseable by either when implementing this.
 */

/*
 * The spl cookie has the bits of the PC registers that correspond to
 * the processor priority (PC.p) and the trace enable bit
 * (PC.te). Other bits may be on or off, but will be ignored.
 */
typedef unsigned long spl_cookie_t;

#if defined(__cplusplus)

#ifndef isr_hot_flag
extern "C" bool isr_hot_flag();
#endif

extern "C" spl_cookie_t thread_splhi();
extern "C" spl_cookie_t thread_spl(spl_cookie_t cookie);
extern "C" void thread_spl_low();

#else

#ifndef isr_hot_flag
extern "C" int isr_hot_flag();
#endif

extern spl_cookie_t thread_splhi();
extern spl_cookie_t thread_spl(spl_cookie_t cookie);
extern void thread_spl_low();
#endif

#endif
