#ifndef __i960_mon960_H
#define __i960_mon960_H
/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: mon960.h,v 1.1 1997/02/21 21:19:34 steve Exp $"
/*
 * $Log: mon960.h,v $
 * Revision 1.1  1997/02/21 21:19:34  steve
 *  Support for MON960 calls.
 *
 */

/*
 * The MON960 monitor is a creation on Intel specifically for the i960
 * series CPUs. It has a few system calls that an application running
 * under it may choose to use, especially for accessing the console on
 * boards that have such a thing.
 *
 * The names used here are mon960_x in place of the sdm_x names that
 * the Intel library uses, in order to keep the excessively generic
 * names out of the namespace.
 */

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Write the buffer to the specified file desctiptor. For
 * mon960, only the values 1 and 2 (stdout and stderr) are valid here.
 */

inline int mon960_write(int fd, const void*buf, size_t size, int*nwrite)
{
      int rc;
      asm __volatile__ ("mov %1, g0; mov %2, g1; mov %3, g2; mov %4, g3\n"
			"ldconst 232, r3; calls r3\n"
			"mov g0, %0"
			: "=l" (rc)
			: "lI" (fd), "l" (buf), "lI" (size), "l" (nwrite)
			: "r3", "g0", "g1", "g2", "g3");
      return rc;
}

#ifdef __cplusplus
}
#endif


#endif
