#ifndef __ucr_IBool_H
#define __ucr_IBool_H
/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *  ---
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 */
#ident "$Id: IBool.h,v 1.1 1998/01/19 23:43:26 steve Exp $"

# include  <ucr/ISync.h>


class IBool  : private ISync {

    public:
      IBool (bool val =false)
      : value_(val)
      { }

      operator bool () const { return value_; }

      IBool& operator= (bool that)
	    { if (that == value_) return *this;
	      value_ = that;
	      wakeup();
	      return *this;
	    }

      void wait_for(bool val =true) const
	    { if (val)
		    sleep(&value_);
	      else
		    sleep(&wait_for_false_, &value_);
	    }

    private:
      bool value_;
      static bool wait_for_false_(const volatile void*);
};


/*
 * $Log: IBool.h,v $
 * Revision 1.1  1998/01/19 23:43:26  steve
 *  Add IBool to ucr
 *
 */
#endif
