#ifndef __ucr_misc_H
#define __ucr_misc_H
/*
 * Copyright (c) 1998 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *  ---
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 */
#ident "$Id: misc.h,v 1.1 1998/07/16 22:52:34 steve Exp $"

/*
 * The ucr library includes a miscellany of functions that are useful
 * in general but are not part of the standard C or C++ library. In
 * fact, some of these may be used to implement standard
 * functions.
 */

/* Write the string of the value into the buffer, and return the
   number of bytes written. The function will write the null, but will
   not count it. */
extern unsigned ucr_stringify(char*buf, unsigned long value, unsigned base);


/*
 * $Log: misc.h,v $
 * Revision 1.1  1998/07/16 22:52:34  steve
 *  Add stringify to ucr misc.
 *
 */
#endif
