/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *  ---
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 */
#ident "$Id: BIOS32_r.cc,v 1.2 1998/06/04 16:44:56 steve Exp $"

# include  <chips/BIOS32.h>
# include  <i960/i960Rx.h>

/*
 * This function resets the secondary PCI bus of the i960Rx. It is a
 * static method because it must be done before the constructor, and I
 * not in general sure that I want to do it in general.
 */

void BIOS32::reset_bus()
{
      BCR |=  0x0040;
      for (unsigned idx = 0 ;  idx < 100000 ;  idx += 1)
	    asm("")/* busy */;
      BCR &= ~0x0040;
      for (unsigned idx = 0 ;  idx < 100000 ;  idx += 1)
	    asm("")/* busy */;
}

/*
 * $Log: BIOS32_r.cc,v $
 * Revision 1.2  1998/06/04 16:44:56  steve
 *  Wider PCI reset pulse.
 *
 * Revision 1.1  1997/11/03 23:25:41  steve
 *  Support PCI bus reset on command.
 *
 */

