/*
 * Copyright (c) 1996-1998 Picture Elements, Inc.
 *    Stephen Williams <steve@picturel.com>
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: BUSChannel.cc,v 1.21 1998/06/06 02:28:49 steve Exp $"

# include  <chips/BUS.h>
# include  <assert.h>


BUS::Channel::Channel(unsigned c)
: master_(0), channel_(c), read_eof_(false), table_(0), magic_(0),
  raddr_(0), rsize_(0), roff_(0), waddr_(0), wsize_(0), woff_(0),
  atten_fun_(0), readable_fun_(0)
{
}

BUS::Channel::~Channel()
{
      master_->close_channel(this);
}

void BUS::Channel::readable(notify_fun f)
{
      readable_fun_ = f;
}

void BUS::Channel::do_attention_(unsigned short arg1, unsigned long arg2)
{
      if (arg1 == 0) switch (arg2) {

	  case 0:
	    break;

	      // This does a reset by clearing all the buffer
	      // lists. This prevents further access to the host,
	      // which is presumably why the reset is being done. Also
	      // mark the frame invalid.
	  case 1:
	    break;

	  default:
	    break;

      } else if (atten_fun_) {
	    atten_fun_(atten_arg_, arg1, arg2);
      }
}

/*
 * $Log: BUSChannel.cc,v $
 * Revision 1.21  1998/06/06 02:28:49  steve
 *  Fix uninitialized write information.
 *
 * Revision 1.20  1998/05/26 16:16:32  steve
 *  New channel protocol
 *
 */
