/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: StdioDevice.cc,v 1.2 1996/10/28 03:45:59 steve Exp $"
/*
 * $Log: StdioDevice.cc,v $
 * Revision 1.2  1996/10/28 03:45:59  steve
 *  License notice.
 *
 * Revision 1.1  1996/09/14 00:10:17  steve
 *  Add a stdio library.
 *
 */

# include  <StdioDevice.h>
# include  <string.h>
# include  <assert.h>

StdioDeviceType * StdioDeviceType::list_ = 0;

StdioDevice::~StdioDevice()
{
}

StdioDeviceType::~StdioDeviceType()
{
}

StdioDeviceType::StdioDeviceType(const char*n)
: left_(0), right_(0)
{
      strcpy(name_, n);
      if (list_ == 0) {
	    list_ = this;
	    return;
      }

      StdioDeviceType*cur = list_;

      for (;;) {
	    assert( strcmp(cur->name_, name_) != 0 );

	    if (strcmp(name_, cur->name_) < 0) {

		  if (cur->left_ == 0) {
			cur->left_ = this;
			break;
		  }

		  cur = cur->left_;

	    } else {

		  if (cur->right_ == 0) {
			cur->right_ = this;
			break;
		  }

		  cur = cur->right_;
	    }
      }
}

StdioDeviceType* StdioDeviceType::find(const char*name)
{
      StdioDeviceType*cur = list_;
      while (cur) {
	    int cc = strcmp(name, cur->name_);

	    if (cc == 0) return cur;
	    if (cc < 0) cur = cur->left_;
	    else cur = cur->right_;
      }

      return 0;
}
