/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: fflush.cc,v 1.3 1996/10/28 03:46:00 steve Exp $"
/*
 * $Log: fflush.cc,v $
 * Revision 1.3  1996/10/28 03:46:00  steve
 *  License notice.
 *
 * Revision 1.2  1996/09/16 17:03:06  steve
 *  Add the read/write state machine.
 *
 * Revision 1.1  1996/09/14 00:10:18  steve
 *  Add a stdio library.
 *
 */

# include  "stdiox.h"
# include  <assert.h>

extern "C" int fflush(FILE*stream)
{
	/* I don't yet support the magic flush everything trick. */
      assert(stream);

      switch (stream->buf_mode) {

	  case _IONBF:
	    break;

	  case _IOFBF:
	  case _IOLBF:
	    if (stream->buf_ptr > stream->buf) {
		  stream->dev->write(stream->buf, stream->buf_ptr-stream->buf);
		  stream->buf_ptr = stream->buf;
	    }
	    break;
      }

      stream->state = _FILE::S_IDLE;

      return 0;
}
