/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: fgets.cc,v 1.2 1996/10/28 03:46:01 steve Exp $"
/*
 * $Log: fgets.cc,v $
 * Revision 1.2  1996/10/28 03:46:01  steve
 *  License notice.
 *
 * Revision 1.1  1996/09/19 01:38:33  steve
 *  Add fgetc and fgets. stdio input works.
 *
 */

# include  "stdiox.h"

/*
 * Do a fairly trivial of fgets that uses fgetc to do all the
 * input. This allows me to ignore the hard stuff.
 */

extern "C" char* fgets(char*str, int cnt, FILE*stream)
{
      char* cp = str;
      while (cnt > 1) {
	    int ch = fgetc(stream);
	    if (ch == EOF) return 0;

	    *cp++ = ch;

	    if (ch == '\n') break;
	    cnt -= 1;
      }

      *cp++ = 0;
      return str;
}
