/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: setvbuf.cc,v 1.5 1997/04/23 22:07:30 steve Exp $"
/*
 * $Log: setvbuf.cc,v $
 * Revision 1.5  1997/04/23 22:07:30  steve
 *  fix broken return code.
 *
 * Revision 1.4  1997/04/21 04:33:39  steve
 *  Fix setting of mode flag.
 *
 * Revision 1.3  1996/10/28 03:46:05  steve
 *  License notice.
 *
 * Revision 1.2  1996/09/16 17:03:09  steve
 *  Add the read/write state machine.
 *
 * Revision 1.1  1996/09/14 00:10:21  steve
 *  Add a stdio library.
 *
 */

# include  <stdio.h>
# include  "stdiox.h"

extern "C" int setvbuf(FILE*stream, char*buf, int mode, size_t size)
{
      if (stream->state != _FILE::S_IDLE) return EOF;

      switch (mode) {

	  case _IONBF:
	    if (stream->buf) {
		  if (stream->buf_ptr > stream->buf) return -1;
		  if (stream->buf_freeme) delete[]stream->buf;
		  stream->buf = 0;
	    }
	    break;

	  case _IOFBF:
	  case _IOLBF:
	    if (stream->buf) {
		  if (stream->buf_ptr > stream->buf) return -1;
		  if (stream->buf_freeme) delete[] stream->buf;
	    }

	    if (buf) {
		  stream->buf = buf;
		  stream->buf_freeme = false;
	    } else {
		  stream->buf = new char[size];
		  stream->buf_freeme = true;
	    }
	    stream->buf_ptr = stream->buf;
	    stream->buf_len = size;
	    break;

	  default:
	    return -1;
      }

      stream->buf_mode = mode;
      return 0;
}
