
/*
 * Copyright (c) 1995 Picture Elements Inc.
 *	Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: heap_selftest.cc,v 1.2 1996/10/28 03:46:25 steve Exp $"
/*
 * $Log: heap_selftest.cc,v $
 * Revision 1.2  1996/10/28 03:46:25  steve
 *  License notice.
 *
 * Revision 1.1  1995/09/07 18:25:10  steve
 *  Seperate heap_selftest from other routines.
 *
 */

# include  <ucr/heap.h>
# include  <assert.h>
# include  "__heap.h"

/*
 * This routine carefully checks the heap space, and will abort if
 * there is a problem.
 */

void heap_self_test(HEAP_SPACE*space)
{
      HeapCell*root = (HeapCell*)space;

      assert( root->free == 2 );
      assert( root->size == 2 );
      assert( root->next > root );
      assert( root[1].next > root );

      HeapCell*cur = root->next;
      while (cur != root) {
	    assert( cur );
	    assert( cur->free == 1 );
	    assert( cur->next[1].next == cur );
	    assert( cur[1].next->next == cur );
	    assert( cur > cur[1].next );

	    if (cur->next != root) {
		  assert( cur->next > cur );
		  assert( cur + cur->size < cur->next );
	    }

	    cur = cur->next;
      }

}
