/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: memset.c,v 1.4 1997/04/17 04:03:13 steve Exp $"
/*
 * $Log: memset.c,v $
 * Revision 1.4  1997/04/17 04:03:13  steve
 *  Use word transfers in memset, if possible.
 *
 * Revision 1.3  1996/11/07 02:27:51  steve
 *  use size_t as required.
 *
 * Revision 1.2  1996/10/28 03:46:30  steve
 *  License notice.
 *
 * Revision 1.1  1996/07/30 05:09:52  steve
 *  Seperate some C routines into seperate files.
 *
 */

# include  <string.h>

#if defined(I960)

void*memset(void*s1, int c, size_t n)
{
      register char*cp = (char*)s1;
      unsigned long cc;

      for (;;) {
	    if (n < 4) goto tail;
	    if (0 == (3 & (unsigned long)cp)) break;
	    *(cp++) = c;
	    n -= 1;
      }

      cc = c & 0xff;
      cc |= cc<<8;
      cc |= cc<<16;

      do {
	    *(unsigned long*)cp = cc;
	    cp += 4;
	    n -= 4;
      } while (n >= 4);
tail:
      switch(n) {
	  case 3:
	    *(cp++) = c;
	  case 2:
	    *(cp++) = c;
	  case 1:
	    *(cp++) = c;
      }

      return s1;
}

#else

void* memset(void*s1, int c, size_t n)
{
      register char*cp = (char*)s1;
      for ( ;  n;  n -= 1)
	*(cp++) = c;
      return s1;
}

#endif
