!
! Copyright (c) 1996 Picture Elements Inc.
!	Stephen Williams (steve@picturel.com)
!
!    This source code is free software; you can redistribute it
!    and/or modify it in source code form under the terms of the GNU
!    Library General Public License as published by the Free Software
!    Foundation; either version 2 of the License, or (at your option)
!    any later version. In order to redistribute the software in
!    binary form, you will need a Picture Elements Binary Software
!    License.
!
!    This program is distributed in the hope that it will be useful,
!    but WITHOUT ANY WARRANTY; without even the implied warranty of
!    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
!    GNU Library General Public License for more details.
!
!    You should have received a copy of the GNU Library General Public
!    License along with this program; if not, write to the
!    Free Software Foundation, Inc.,
!    59 Temple Place - Suite 330
!    Boston, MA 02111-1307, USA
!
!    You should also have recieved a copy of the Picture Elements
!    Binary Software License offer along with the source. This offer
!    allows you to obtain the right to redistribute the software in
!    binary (compiled) form. If you have not received it, contact
!    Picture Elements, Inc.,
!    777 Panoramic Way
!    Berkeley, CA 94704.
!
.ident "$Id: setjmp-sparc.s,v 1.1 1996/11/12 00:38:52 steve Exp $"
!
! $Log: setjmp-sparc.s,v $
! Revision 1.1  1996/11/12 00:38:52  steve
!  Implement the sparc longjmp, fix the IEEEFP byte
!  extraction for sparc, add the UCR_STACK_ATTRIBUTE
!  definition and get the regress test to work for sparc_linux.
!
!
	.file "setjmp-linux.s"

! The setjmp saves the stack pointer and return instruction pointer
! in the jmp_buf array, and the longjmp uses them to restore the stack.

! extern "C" int setjmp(jmp_buf env)

	.global setjmp
setjmp:
	save	%sp,-64,%sp

	st	%fp, [%i0 + 0]
	st	%i7, [%i0 + 4]
	
	mov	0, %i0
	ret
	restore

! extern "C" void longjmp(jmp_buf env, int val)

	.global longjmp
longjmp:
	save	%sp,-64,%sp

  ! Spill the register windows and recover the frame pointer from the
  ! jmp_buf. Get the return instruction pointer as well.

	ta	3
	ld	[%i0 + 0], %fp
	ld	[%i0 + 4], %i7

  ! Set up val as the return code. If it is 0, return 1 instead.

	orcc	%i1, 0, %i0
	bne	0f
	nop
	mov	1, %i0
0:
  ! This return puts us back on the stack and return address where the
  ! setjmp marked. The intentional spill causes the previous window
  ! to be pulled from the stack.

	ret
	restore
