/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: strtol.c,v 1.1 1997/04/25 18:46:16 steve Exp $"
/*
 * $Log: strtol.c,v $
 * Revision 1.1  1997/04/25 18:46:16  steve
 *  More ISO C support.
 *
 */

# include  <stdlib.h>

long strtol(const char*nptr, char**endptr, int base)
{
      long result = 0;
      long sign = 1;

      if (base == 0) {
	    if (nptr[0] == '0')
	      if ( (nptr[1]| ' ') == 'x')
		base = 16;
	      else
		base = 8;
	    else
	      base = 10;
      }

      if ( (base == 16) && (nptr[0] == '0') && ((nptr[1]|' ') == 'x'))
	nptr += 2;

      switch (*nptr) {
	  case '-':
	    sign = -1;
	  case '+':
	    nptr += 1;
	    break;
      }

      while (*nptr) {
	    unsigned long value = *nptr - '0';
	    if (value > 9) value = (*nptr | ' ') - 'a' + 10;
	    if (value >= base) break;

	    result = result*base + value;
	    nptr += 1;
      }

      if (endptr) *endptr = (char*)nptr;
      return result * sign;
}
