
/*
 * Copyright (c) 1995 Picture Elements Inc.
 *	Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: strtoul.c,v 1.2 1996/10/28 03:46:39 steve Exp $"
/*
 * $Log: strtoul.c,v $
 * Revision 1.2  1996/10/28 03:46:39  steve
 *  License notice.
 *
 * Revision 1.1  1995/09/03 05:27:23  steve
 *  Add some defaults for fault handlers.
 *  Add more ANSI standard support into the stdlib.h
 *  header file, and add the strtoul() routine to
 *  the library.
 *
 */

# include  <stdlib.h>


/*
 * The behavior of this function comes from the ANSI-C standard. It
 * assumes ASCII characters.
 */
unsigned long strtoul(const char*string, char**endptr, int base)
{
      unsigned long result = 0;

      if (base == 0) {
	    if (string[0] == '0')
	      if ( (string[1]| ' ') == 'x')
		base = 16;
	      else
		base = 8;
	    else
	      base = 10;
      }

      if ( (base == 16) && (string[0] == '0') && ((string[1]|' ') == 'x'))
	string += 2;

      while (*string) {
	    unsigned long value = *string - '0';
	    if (value > 9) value = (*string | ' ') - 'a' + 10;
	    if (value >= base) break;

	    result = result*base + value;
	    string += 1;
      }

      if (endptr) *endptr = (char*)string;
      return result;
}
