
#
# Copyright (c) 1995 Picture Elements Inc.
#	Stephen Williams
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
.ident "$Id: uCR_fault-i960.s,v 1.3 1996/10/28 03:46:44 steve Exp $"
#
# $Log: uCR_fault-i960.s,v $
# Revision 1.3  1996/10/28 03:46:44  steve
#  License notice.
#
# Revision 1.2  1996/10/04 01:24:43  steve
#  Remember to clear g14 for the fault frame.
#
# Revision 1.1  1996/09/19 04:44:19  steve
#  Add the i960_ise target, change the target
#  configuration headers to allow sharing by
#  targets, fix up the make clean rule.
#
# Revision 1.2  1996/08/24 20:51:54  steve
#  Oops, loaded too many registers.
#
# Revision 1.1  1996/08/10 22:06:57  steve
#  Add generic fault handling code.
#

	.file	"uCR_fault.s"

 # A fault is more like a simple call then an interrupt, but can still
 # be unpredictable so I must save registers. Trouble is, the fault
 # is still possibly interruptible so I must use the stack for this
 # and not the thread structure. Once I do this, the danger is over
 # and I can call the C++ code to to generic stuff.

	.global	_uCR_fault_common
	.balign	8
_uCR_fault_common:
	mov	sp, r4
	setbit	6, 0, r5
	addo	r5, sp, sp

	stq	g0,  0(r4)
	stq	g4, 16(r4)
	stq	g8, 32(r4)
	stq	g12,48(r4)

 # Call the generic code with a pointer to the fault table. The
 # interpretation of the fault table is up to the application.

	lda	-64(fp), g0
	mov	0, g14
	call	_uCR_fault_base

	ldt	48(r4), g12
	ldq	32(r4), g8
	ldq	16(r4), g4
	ldq	 0(r4), g0

	ret
