
#
# Copyright (c) 1995 Picture Elements Inc.
#	Stephen Williams
#
#    This source code is free software; you can redistribute it
#    and/or modify it in source code form under the terms of the GNU
#    Library General Public License as published by the Free Software
#    Foundation; either version 2 of the License, or (at your option)
#    any later version. In order to redistribute the software in
#    binary form, you will need a Picture Elements Binary Software
#    License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Library General Public License for more details.
#
#    You should have received a copy of the GNU Library General Public
#    License along with this program; if not, write to the Free
#    Software Foundation, Inc.,
#    59 Temple Place - Suite 330
#    Boston, MA 02111-1307, USA
#
#    You should also have recieved a copy of the Picture Elements
#    Binary Software License offer along with the source. This offer
#    allows you to obtain the right to redistribute the software in
#    binary (compiled) form. If you have not received it, contact
#    Picture Elements, Inc.,
#    777 Panoramic Way
#    Berkeley, CA 94704.
#
#ident "$Id: uCR_isr-m68k_coff.s,v 1.3 1997/02/21 21:43:26 steve Exp $"
#
# $Log: uCR_isr-m68k_coff.s,v $
# Revision 1.3  1997/02/21 21:43:26  steve
#  Update m68k support for newer config structure.
#
# Revision 1.2  1996/10/28 03:46:45  steve
#  License notice.
#
# Revision 1.1  1996/05/29 04:36:07  steve
#  Support interrupts in the i960_cyclone world, and in the
#  process reorganize interrupt code for portability.
#
# Revision 1.1  1996/05/24 01:46:42  steve
#  Initial port to i960_cyclone
#  Seperate some files in the library to seperate files
#  for making smaller binaries, use uCR_ prefix for private
#  symbols, move assembly files around for compile-time
#  portability, change __start to ucr_start and give it
#  new behavior, and simplify the ucr_assert implementation.
#
# Revision 1.4  1995/12/07 04:30:27  steve
#  Simplify fault handling.
#
# Revision 1.3  1995/12/05 19:27:14  steve
#  Let assembler use ADDq.
#
# Revision 1.2  1995/09/25 00:28:53  steve
#  Optimize ISR selection and dispatch, and try
#  to speed up handling of time.
#
# Revision 1.1  1995/09/02 18:27:25  steve
#  Initial import of UCR core to cvs.
#
#


# This are standard exception handler.  I now save the registers,
# push the exception number on the front of the stack and call the
# C version. It is the duty of the called C/C++ functions to save
# registers they use, and restore them when they are done. Here, I
# only save %d0, %d1, %a0 and %a1.
#
# NOTE:	The interrupt vector table points to these, so I must RTE
#       when done.

	.text
	.global __isr_0, __isr_1, __isr_2, __isr_3
	.global __isr_4, __isr_5, __isr_6, __isr_7

__isr_0:moveml	#0xc0c0,-(%sp)
	moveq	#0,%d0
	bra	__isr

__isr_1:moveml	#0xc0c0,-(%sp)
	moveq	#1,%d0
	bra	__isr

__isr_2:moveml	#0xc0c0,-(%sp)
	moveq	#2,%d0
	bra	__isr

__isr_3:moveml	#0xc0c0,-(%sp)
	moveq	#3,%d0
	bra	__isr

__isr_4:moveml	#0xc0c0,-(%sp)
	moveq	#4,%d0
	bra	__isr

__isr_5:moveml	#0xc0c0,-(%sp)
	moveq	#5,%d0
	bra	__isr

__isr_7:moveml	#0xc0c0,-(%sp)
	moveq	#7,%d0
	bra	__isr


__isr_6:moveml	#0xc0c0,-(%sp)
	moveq	#6,%d0
	| bra	__isr		... fall through OK here.

__isr:
	ori	#0x0700,%sr

			| Get the exception number from the jumper
			| that jumped here.
	movel	%d0,-(%sp)
	movel	#1, uCR_isr_hot_flag
	jsr	uCR_isr_base

	add	#4,%sp
	moveml	(%sp)+,#0x0303

	movel	#0, uCR_isr_hot_flag

	rte

	.data
	.global uCR_isr_hot_flag
uCR_isr_hot_flag:
	.long	0
