/*
 * Copyright (c) 1998 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *  ---
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 */
#ident "$Id: ucr_stringify.cc,v 1.1 1998/07/16 22:52:34 steve Exp $"

# include  <ucr/misc.h>

static const char hex_chars[] = "0123456789abcdef";

unsigned ucr_stringify(char*buf, unsigned long value, unsigned base)
{
      char*cp = buf;
      while (value) {
	    *cp++ = hex_chars[value%base];
	    value /= base;
      }

      if (cp == buf) {
	    *cp++ = '0';
	    *cp = 0;
	    return 1;
      }

      *cp = 0;

	/* I made the string in the wrong order. Reverse the string
	   with this while loop. */
      char*head = buf;
      char*tail = cp-1;
     
      while (tail > head) {
	    char tmp = *tail;
	    *tail = *head;
	    *head = tmp;
	    head += 1;
	    tail -= 1;
      }

      return cp - buf;
}


/*
 * $Log: ucr_stringify.cc,v $
 * Revision 1.1  1998/07/16 22:52:34  steve
 *  Add stringify to ucr misc.
 *
 */

