/*
 * Copyright (c) 1997 Picture Elements, Inc.
 *    Stephen Williams (steve@picturel.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *  ---
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 */
#ident "$Id: udlsym.cc,v 1.1 1997/09/04 01:05:45 steve Exp $"

# include  <udlfcn.h>
# include  "__udlfcn.h"
# include  <string.h>

void* udlsym(udl_handle*hp, const char*sym)
{
      if (hp->symbol_table == 0) return 0;
      if (hp->symbol_table[0] != UDL_SYMBOL_MAGIC) return 0;

      const unsigned long*values = hp->symbol_table+3;
      const char*names = (const char*)(values + hp->symbol_table[2]);

      while (names[0]) {
	    if (strcmp(names,sym) == 0)
		  return (void*)values[0];

	    if ((names[0] == '_') && (strcmp(names+1,sym) == 0))
		  return (void*)values[0];

	    names += strlen(names) + 1;
	    values += 1;
      }

      return 0;
}

/*
 * $Log: udlsym.cc,v $
 * Revision 1.1  1997/09/04 01:05:45  steve
 *  Add the udlsym function.
 *
 */

