/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    Library General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU Library General Public License for more details.
 *
 *    You should have received a copy of the GNU Library General Public
 *    License along with this program; if not, write to the Free
 *    Software Foundation, Inc.,
 *    59 Temple Place - Suite 330
 *    Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc.,
 *    777 Panoramic Way
 *    Berkeley, CA 94704.
 */
#ident "$Id: main-i960_ise.cc,v 1.5 1997/09/02 21:49:36 steve Exp $"
/*
 * $Log: main-i960_ise.cc,v $
 * Revision 1.5  1997/09/02 21:49:36  steve
 *  Fix broken thread test.
 *
 * Revision 1.4  1997/08/30 03:03:49  steve
 *  Update for newer BUS class.
 *
 * Revision 1.3  1997/02/21 21:22:18  steve
 *  Incorporate stdio interfacce to BUS cnannels.
 *
 * Revision 1.2  1996/11/11 05:39:11  steve
 *  Get the target-specific main into a seperate function
 *  in order to do a stop on some targets, and make the
 *  thread test more synchronous.
 *
 * Revision 1.1  1996/11/10 23:38:52  steve
 *  Add a regression test to uCR.
 *
 */

# include  <ucr/ucr.h>
# include  <ucr/ISync.h>
# include  <stdio.h>
# include  <assert.h>
# include  <chips/BUS.h>
# include  <chips/bus_stdio.h>
# include  <chips/I960RP.h>

BUS bus;

I960RP i960rp;

ChannelDeviceType bus_device("channel", &bus);

static FILE*init_stdout()
{
      bus.open_device(&i960rp);
      return fopen("channel:0", "w");
}


void ucr_assert(const char*file, unsigned line)
{
      fprintf(stdout, "TEST FAILED at %s:%u\n", file, line);
      fflush(stdout);

      for (;;) thread_yield();
}

FILE*const stdout = init_stdout();

extern int main_comm();

main()
{
      main_comm();

      {
	    bool stop_flag;
	    ISync stop;
	    stop.sleep(&stop_flag);
      }
}
