/*
 * Copyright (c) 1996 Picture Elements, Inc.
 *    Stephen Williams (steve@picture.com)
 *
 *    This source code is free software; you can redistribute it
 *    and/or modify it in source code form under the terms of the GNU
 *    General Public License as published by the Free Software
 *    Foundation; either version 2 of the License, or (at your option)
 *    any later version. In order to redistribute the software in
 *    binary form, you will need a Picture Elements Binary Software
 *    License.
 *
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 *
 *    You should also have recieved a copy of the Picture Elements
 *    Binary Software License offer along with the source. This offer
 *    allows you to obtain the right to redistribute the software in
 *    binary (compiled) form. If you have not received it, contact
 *    Picture Elements, Inc., 777 Panoramic Way, Berkeley, CA 94704.
 */
#ident "$Id: setjmp_test.cc,v 1.1 1996/11/10 23:38:53 steve Exp $"
/*
 * $Log: setjmp_test.cc,v $
 * Revision 1.1  1996/11/10 23:38:53  steve
 *  Add a regression test to uCR.
 *
 */

# include  <stdio.h>
# include  <setjmp.h>
# include  <assert.h>

static jmp_buf test_buf;
static unsigned count;

static void subframe(FILE*out);

void setjmp_test(FILE*out)
{
      count = 0;
      if (setjmp(test_buf) == 0) {

	    assert( count == 0 );
	    fprintf(out, "... setjmp save the context.\n");
	    fflush(out);
	    subframe(out);
	    assert(0);

      } else {

	    assert( count == 1 );
	    fprintf(out, "... longjmp was completed.\n");
	    fflush(out);
      }

}

static void subframe(FILE*out)
{
      count += 1;
      longjmp(test_buf, 0);
      assert(0);
}
